#-----------------------------------------------------------------------#
#																		#
#	Program:	Imageer													#
#	File:		Imageer.make	-	Make Source							#
#																		#
#	By:			Jason Hodges-Harris										#
#																		#
#	Version:	1.0d2													#
#																		#
#	Copyright:	 1995-96 Apple Computer, Inc.,							#
#					all rights reserved.								#	
#																		#
#-----------------------------------------------------------------------#

AppName			=	'Imageer'
Signature		=	'Im#'
projsrc			=	:source:
C				=	SC
obj				= 	:object:
SymOptions		=	-mc68020 -sym on 
SymOptions2		=	-sym on -w 
COptions		=	{SymOptions} 
LinkOptions		=	{SymOptions2} # {SegmentMappings} 

SegmentMappings	=	-sn INTENV = Main 
					-sn STDCLIB = Main 
					-sn SANELIB = Main 
					-sn StringUtils = Main 
					-sn UtilMain = Main 
					-sn STDIO = Main 
					-sn CSANELib = Main 


{obj}				{projsrc}

{obj}.c.o			{projsrc}.c
	{C} 			{COptions} {DepDir}{Default}.c -o {TargDir}{Default}.c.o

#------------------------------------------------------------------------------
# These are the objects that we want to link with. If any one of these
# changes, then we invoke the Link command.
#------------------------------------------------------------------------------

AppObjects		=	
					{obj}doevent.c.o 
					{obj}eventloop.c.o 
					{obj}fileCache.c.o 
					{obj}fileIO.c.o 
					{obj}gxGraphics.c.o 
					{obj}imageFilter.c.o 
					{obj}menu.c.o 
					{obj}offscrnGraphics.c.o 
					{obj}start.c.o 
					{obj}windows.c.o

					
					

CSysObjects 	= 	
					{Libraries}"IntEnv.o" 
					{CLibraries}"StdCLib.o" 
					{Libraries}"Interface.o" 
					{Libraries}"MacRuntime.o" 
					{Libraries}"ToolLibs.o"
	
{AppObjects}		Imageer.make 
					{projsrc}Imageer.app.h 
					{projsrc}Imageer.protos.h 


{AppName}		 	ShellForce

# With the above rule, {AppName} will always be out of date with respect to
# the non-existent file ShellForce.  This will force the following commands to
# be executed.
ShellForce		
	BEGIN
		IF "{ShellVersion}" == ""
			( EVALUATE "`Version`" =~ /MPW Shell ([0-9]+(.[ab0-9]+)+)1/ )  Dev:Null
			SET ShellVersion "{1}"
		END
	END  Dev:Null # Output to bit bucket so we dont see above calculations

#------------------------------------------------------------------------------
# Build rule that links our application together. If any of our objects 
# changes, or this makefile changes, then we relink.  The dummy prerequisite
# ShellForce must come before any other prerequisites for {AppName}
#------------------------------------------------------------------------------

{AppName}			{AppObjects}
	Rez -append {projsrc}Imageer.r -o {AppName}
	Link {LinkOptions} -o {Targ} {AppObjects} {CSysObjects}
	SetFile {Targ} -t APPL -c {Signature} -a B

#------------------------------------------------------------------------------
# Build rule that creates our resources and adds them to the application
#------------------------------------------------------------------------------

{AppName}			Imageer.make 
					{projsrc}Imageer.app.h
