#-----------------------------------------------------------------------#
#																		#
#	Program:	ImageerFAT												#
#	File:		ImageerFAT.make	-	Make Source							#
#																		#
#	By:			Jason Hodges-Harris										#
#																		#
#	Version:	1.0d2													#
#																		#
#	Copyright:	 1995-96 Apple Computer, Inc.,							#
#					all rights reserved.								#	
#																		#
#-----------------------------------------------------------------------#

AppName			=	'ImageerFAT'
Signature		=	'Im#'
projsrc			=	:source:
PPCC			=	MrC
C				=	SC
obj				=	:object:
COptions		=	{SymOptions} 
SymOptions		=	-mc68020 -sym on 
SymOptions2		=	-sym on -w
SymPPC     	=	-sym on
OptsPPC		=	
ObjDirPPC		=	:object:
LinkOptions		=	{SymOptions2}

PPCCOptions		=	{Includes} {SymPPC} {OptsPPC}

{obj}				{projsrc}

{obj}.c.x			{projsrc}.c
	{MrC} {PPCCOptions} {DepDir}{Default}.c -o {TargDir}{Default}.c.x

{obj}				{projsrc}
{obj}.c.o			{projsrc}.c
	{C} 			{COptions} {DepDir}{Default}.c -o {TargDir}{Default}.c.o


#------------------------------------------------------------------------------
# These are the objects that we want to link with. If any one of these
# changes, then we invoke the Link command.
#------------------------------------------------------------------------------

App68kObjects	=	
					{obj}doevent.c.o 
					{obj}eventloop.c.o 
					{obj}fileCache.c.o 
					{obj}fileIO.c.o 
					{obj}gxGraphics.c.o 
					{obj}imageFilter.c.o 
					{obj}menu.c.o 
					{obj}offscrnGraphics.c.o 
					{obj}start.c.o 
					{obj}windows.c.o

					
					

CSysObjects 	= 	
					{Libraries}"IntEnv.o" 
					{CLibraries}"StdCLib.o" 
					{Libraries}"Interface.o" 
					{Libraries}"MacRuntime.o" 
					{Libraries}"ToolLibs.o"

AppPPCObjects		=	
					{obj}doevent.c.x 
					{obj}eventloop.c.x 
					{obj}fileCache.c.x 
					{obj}fileIO.c.x 
					{obj}gxGraphics.c.x 
					{obj}imageFilter.c.x 
					{obj}menu.c.x 
					{obj}offscrnGraphics.c.x 
					{obj}start.c.x 
					{obj}windows.c.x

PPCSysObjects = 
		"{SharedLibraries}"InterfaceLib 
		"{SharedLibraries}"StdCLib 
		"{SharedLibraries}MathLib" 
		"{SharedLibraries}"QuickTimeLib 
		"{PPCLibraries}"StdCRuntime.o 
		"{PPCLibraries}"PPCCRuntime.o 
		"{PPCLibraries}"PPCToolLibs.o 
		"{PPCLibraries}"QuickDrawGXLib.xcoff 
		-librename QuickDrawGXLib.xcoff=QuickDrawGXLib 
		-weakLib QuickTimeLib 
		-weakLib QuickDrawGXLib


{AppName}		 	ShellForce

ShellForce		
	BEGIN
		IF "{ShellVersion}" == ""
			( EVALUATE "`Version`" =~ /MPW Shell ([0-9]+(.[ab0-9]+)+)1/ )  Dev:Null
			SET ShellVersion "{1}"
		END
	END  Dev:Null # Output to bit bucket so we dont see above calculations

#------------------------------------------------------------------------------
# Build rule that links our application together. If any of our objects 
# changes, or this makefile changes, then we relink.  The dummy prerequisite
# ShellForce must come before any other prerequisites for {AppName}
#------------------------------------------------------------------------------

{AppName}			{App68kObjects}
	Rez -append {projsrc}Imageer.r -o {AppName}
	Link {LinkOptions} -o {Targ} {App68kObjects} {CSysObjects}

{AppName}			{AppPPCObjects}
	PPCLink {SymPPC} -w 
		-o {Targ} {AppPPCObjects} 
		-t APPL 
		-c {Signature} 
		{PPCSysObjects}
	SetFile {Targ} -t APPL -c {Signature} -a B

#------------------------------------------------------------------------------
# Build rule that creates our resources and adds them to the application
#------------------------------------------------------------------------------

{AppName}			ImageerFAT.make 
					{projsrc}Imageer.app.h 
					{projsrc}Imageer.protos.h

