/*
**	Apple Macintosh Developer Technical Support
**
**	Headers for routines demonstrating how to manage interrupt routines for sound play.
**
**	by Mark Cookson, Apple Developer Technical Support
**
**	File:	Interrupt_Routines.h
**
**	Copyright 1996 Apple Computer, Inc.
**	All rights reserved.
**
**	You may incorporate this sample code into your applications without
**	restriction, though the sample code has been provided "AS IS" and the
**	responsibility for its operation is 100% yours.  However, what you are
**	not permitted to do is to redistribute the source as "Apple Sample
**	Code" after having made changes. If you're going to re-distribute the
**	source, we require that you make it clear in the source that the code
**	was descended from Apple Sample Code, but that you've made changes.
*/

#ifndef __INTERRUPT_ROUTINES__
#define __INTERRUPT_ROUTINES__

#include <Sound.h>

#ifndef __SOUNDSTRUCT__
#include "SoundStruct.h"
#endif

#ifndef __DBFFERRORS__
#include "DBFF_Errors.h"
#endif

#ifndef __DOUBLEBUFFERFROMFILE__
#include "DoubleBufferFromFile.h"
#endif

#ifndef __MUNGEBUFFER__
#include "MungeBuffer.h"
#endif

#ifndef __DEFINES__
#include "Defines.h"
#endif

/* Function declarations */
#ifdef powerc
pascal	void	ASoundFileCallBack		(myParmBlkPtr mypb);
#else
pascal	void	ASoundFileCallBack		(myParmBlkPtr mypb:__a0);
#endif
pascal	void	ASoundDoubleBackProc	(SndChannelPtr chan,
										SndDoubleBufferPtr doubleBuffer);
pascal	void	ASoundDoneCallBack		(SndChannelPtr chan,
										SndCommand *cmd);

extern Boolean	gBackwards, gSoundDone;

#endif
