#ifndef __SPEACHCALLBACKS__
#include "SpeechCallbacks.h"
#endif

OSErr		SetSpeechDoneCallback	(const SpeechChannel theSpeechChan)
{
	OSErr		theErr		= noErr;

	theErr = SetSpeechInfo (theSpeechChan, soSpeechDoneCallBack, NewSpeechDoneProc (SpeechDoneCallback));
	if (theErr != noErr) {
		DebugStr ("\pSetSpeechInfo (SetSpeechDoneCallback) error");
	}

	return theErr;
}

OSErr		SetWordCallback			(const SpeechChannel theSpeechChan)
{
	OSErr		theErr		= noErr;

	theErr = SetSpeechInfo (theSpeechChan, soWordCallBack, NewSpeechWordProc (WordCallback));
	if (theErr != noErr) {
		DebugStr ("\pSetSpeechInfo (SetWordCallback) error");
	}

	return theErr;
}

pascal void SpeechDoneCallback		(const SpeechChannel theSpeechChan,
									const long refCon)
{
#pragma unused (theSpeechChan)

	if (refCon == 'test') {
//		DebugStr ("\pEntering MySpeechDoneCallback, all is good.");
	}
	else {
		DebugStr ("\pEntering MySpeechDoneCallback, all is NOT good.");
	}	
}

pascal void WordCallback			(const SpeechChannel theSpeechChan,
									const long refCon,
									const long wordPos,
									const short wordLen)
{
#pragma unused (theSpeechChan)
#pragma unused (wordPos)
#pragma unused (wordLen)

	if (refCon == 'test') {
//		DebugStr ("\pEntering MyWordCallback, all is good.");
	}
	else {
		DebugStr ("\pEntering MyWordCallback, all is NOT good.");
	}	
}
